<!-- @format -->

<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryRef"
      :inline="true"
      v-show="showSearch"
      label-width="120px"
    >
      <el-form-item label="材料名称" prop="materialsName">
        <el-input
          v-model="queryParams.materialsName"
          placeholder="请输入材料名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="材料形式" prop="materialsShape">
        <el-select
          style="width: 100%"
          v-model="queryParams.materialsShape"
          placeholder="请输入材料形式"
        >
          <el-option
            v-for="item of materials_shape"
            :label="item.label"
            :value="item.value"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="是否必传" prop="isMust">
        <el-select
          style="width: 100%"
          v-model="queryParams.isMust"
          placeholder="请输入是否必传"
        >
          <el-option label="必传" value="1"></el-option>
          <el-option label="非必传" value="0"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="类型" prop="cardType">
        <el-select
          v-model="queryParams.cardType"
          placeholder="请选择类型"
          clearable
        >
          <el-option
            v-for="dict in card_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['materials:conifg:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['materials:conifg:edit']"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['materials:conifg:remove']"
          >删除</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['materials:conifg:export']"
          >导出</el-button
        >
      </el-col>
      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="conifgList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号" align="center" width="55" type="index" />
      <el-table-column label="材料名称" align="center" prop="materialsName" />
      <el-table-column label="材料形式" align="center" prop="materialsShape">
        <template #default="scope">
          <dict-tag
            :options="materials_shape"
            :value="scope.row.materialsShape"
          />
        </template>
      </el-table-column>
      <el-table-column label="是否必传" align="center" prop="isMust">
        <template #default="scope">
          <dict-tag :options="is_must" :value="scope.row.isMust" />
        </template>
      </el-table-column>
      <el-table-column label="类型" align="center" prop="cardType">
        <template #default="scope">
          <dict-tag :options="card_type" :value="scope.row.cardType" />
        </template>
      </el-table-column>
      <el-table-column
        label="要求"
        align="center"
        prop="remark"
      ></el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template #default="scope">
          <el-button
            link
            type="primary"
            icon="Edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['materials:conifg:edit']"
            >修改</el-button
          >
          <el-button
            link
            type="primary"
            icon="Delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['materials:conifg:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改材料配置对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="conifgRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="材料名称" prop="materialsName">
          <el-input v-model="form.materialsName" placeholder="请输入材料名称" />
        </el-form-item>
        <el-form-item label="材料形式" prop="materialsShape">
          <el-select
            style="width: 100%"
            v-model="form.materialsShape"
            placeholder="请输入材料形式"
          >
            <el-option
              v-for="item of materials_shape"
              :label="item.label"
              :value="item.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="是否必传" prop="isMust">
          <el-select
            style="width: 100%"
            v-model="form.isMust"
            placeholder="请输入是否必传"
          >
            <el-option label="必传" value="1"></el-option>
            <el-option label="非必传" value="0"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="类型" prop="cardType">
          <el-select
            style="width: 100%"
            v-model="form.cardType"
            placeholder="请选择类型"
          >
            <el-option
              v-for="dict in card_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="要求" prop="remark">
          <el-input
            :rows="3"
            v-model="form.remark"
            type="textarea"
            placeholder="请输入要求"
          ></el-input>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Conifg">
import {
  listConifg,
  getConifg,
  delConifg,
  addConifg,
  updateConifg,
} from "@/api/mattersClass/materialSetting";
import { ElOption } from "element-plus";

const { proxy } = getCurrentInstance();
const { card_type, materials_shape, is_must } = proxy.useDict(
  "card_type",
  "materials_shape",
  "is_must"
);

const conifgList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    materialsName: null,
    materialsShape: null,
    isMust: null,
    cardType: null,
  },
  rules: {
    materialsName: [
      {
        required: true,
        message: "材料内容不能为空",
        trigger: "blur",
      },
    ],
    materialsShape: [
      {
        required: true,
        message: "材料形式不能为空",
        trigger: "blur",
      },
    ],
    isMust: [
      {
        required: true,
        message: "是否必传不能为空",
        trigger: "blur",
      },
    ],
    cardType: [
      {
        required: true,
        message: "卡片类型不能为空",
        trigger: "blur",
      },
    ],
  },
});

const { queryParams, form, rules } = toRefs(data);

/** 查询材料配置列表 */
function getList() {
  loading.value = true;
  listConifg(queryParams.value).then((response) => {
    conifgList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    materialsName: null,
    materialsShape: null,
    isMust: null,
    cardType: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    remark: null,
  };
  proxy.resetForm("conifgRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加材料配置";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value;
  getConifg(_id).then((response) => {
    form.value = response.data;
    open.value = true;
    title.value = "修改材料配置";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["conifgRef"].validate((valid) => {
    if (valid) {
      if (form.value.id != null) {
        updateConifg(form.value).then((response) => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addConifg(form.value).then((response) => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal
    .confirm('是否确认删除材料配置编号为"' + _ids + '"的数据项？')
    .then(function () {
      return delConifg(_ids);
    })
    .then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    })
    .catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    "materials/conifg/export",
    {
      ...queryParams.value,
    },
    `conifg_${new Date().getTime()}.xlsx`
  );
}

getList();
</script>
